=== modified file 'plugin/innobase/row/row0row.c'
--- plugin/innobase/row/row0row.c	2009-03-12 23:13:55 +0000
+++ plugin/innobase/row/row0row.c	2009-05-02 23:36:10 +0000
@@ -968,9 +968,11 @@
 	ulint	ret;
 	ibool	format_in_hex;
 
+        ret = 0;
+
 	if (buf_size == 0) {
 
-		return(0);
+		return(ret);
 	}
 
 	if (data_len == UNIV_SQL_NULL) {

=== added file 'tests/r/default_collation.result'
--- tests/r/default_collation.result	1970-01-01 00:00:00 +0000
+++ tests/r/default_collation.result	2009-05-02 23:57:11 +0000
@@ -0,0 +1,47 @@
+create database mysqltest collate = utf8_bin;
+use mysqltest;
+create table t1 (a varchar(10));
+create table t2 (a varchar(10)) collate = utf8_general_ci;
+insert into t1 values ('a'),('A'),('aA'),('Aa'),('ab'),('Ab');
+insert into t2 values ('a'),('A'),('aA'),('Aa'),('ab'),('Ab');
+select * from t1 order by a;
+a
+A
+Aa
+Ab
+a
+aA
+ab
+select * from t2 order by a;
+a
+a
+A
+aA
+Aa
+ab
+Ab
+show create table t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` varchar(10) COLLATE utf8_bin DEFAULT NULL
+) ENGINE=InnoDB
+show create table t2;
+Table	Create Table
+t2	CREATE TABLE `t2` (
+  `a` varchar(10) DEFAULT NULL
+) ENGINE=InnoDB
+select count(*) from t1 where a='a';
+count(*)
+1
+select count(*) from t2 where a='a';
+count(*)
+2
+select count(*) from t1 where a like 'a%';
+count(*)
+3
+select count(*) from t2 where a like 'a%';
+count(*)
+6
+drop table if exists t1;
+drop table if exists t2;
+drop database if exists mysqltest;

=== added file 'tests/t/default_collation.test'
--- tests/t/default_collation.test	1970-01-01 00:00:00 +0000
+++ tests/t/default_collation.test	2009-05-02 23:57:11 +0000
@@ -0,0 +1,44 @@
+# 
+# test for per-db default collation
+# this should become the default for tables created in that db
+#
+# https://blueprints.launchpad.net/drizzle/+spec/default-collation-test
+#
+
+# assuming system default collation is utf8_general_ci
+
+create database mysqltest collate = utf8_bin;
+
+use mysqltest;
+
+create table t1 (a varchar(10));
+
+create table t2 (a varchar(10)) collate = utf8_general_ci;
+
+insert into t1 values ('a'),('A'),('aA'),('Aa'),('ab'),('Ab');
+
+insert into t2 values ('a'),('A'),('aA'),('Aa'),('ab'),('Ab');
+
+select * from t1 order by a;
+
+select * from t2 order by a;
+
+show create table t1;
+
+show create table t2;
+
+select count(*) from t1 where a='a';
+
+select count(*) from t2 where a='a';
+
+select count(*) from t1 where a like 'a%';
+
+select count(*) from t2 where a like 'a%';
+
+drop table if exists t1;
+
+drop table if exists t2;
+
+drop database if exists mysqltest;
+
+

